2024快手面试算法题-生气传染

问题描述

思路分析

生气只会向后传播,最后一个生气的人一定是最长连续没有生气的人中的最后一个人,前提是前面得有一个人生气。

注意,一次只能传播一个人,比如示例1,第一次只会传播给第一个P,不会传播给第二个P,了解这个之后,我们再将这个问题进行转化

最后一个P变生气,是由离他最近的A传染的,所以最后一个P变生气的时间,就是最后一个P和离他最近的A的距离

所以我们只要记录离最后一个P最近的A的位置,和最后一个P的位置,两个位置相减就是答案

代码实现

java 复制代码
public class KsInternShip {
	//思路 最后一个p变生气,是由他前面最近的一个A引起的
	//所以最后一个p变成A的时间,就是最后一个P和最近的A的距离
	public int lastToBeAngry(String mood) {
		if(mood == null || mood.length() <= 1) {
			return -1;
		}
		int lastIndex = 0, res = 0, len = mood.length();
		for(int i = 0; i < len; i++) {
			if(mood.charAt(i) == 'A') {
				lastIndex = i;
			}else {
				res = Math.max(res,i - lastIndex);
			}
		}
		return res;
	}
}

相似题目

洛谷的一道相似题:Angry Students - 洛谷

相关推荐
Nil2083 小时前
leetcode 118杨辉三角
算法·leetcode·职场和发展
wanderist.5 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.6 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_307779136 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂6 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年7 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO97 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude7 小时前
c语言:递归
java·c语言·算法
edtoplort8 小时前
OpenAI紧急叫停GPT-6.1 Astra训练,奥尔特曼为何踩刹车
人工智能·gpt·算法
蒜香可达鸭8 小时前
让视频生成流水线跑不崩:一个事件溯源的多 Agent 可靠执行框架
算法